<?php

namespace Service;

use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Zmart\DataSource\ZmartFilterCriteria;

class StyleService {

    protected $dataSourceName = 'style';
    protected $orgMongoManager;
    protected $baseMongoManager;

    public function __construct (Manager $orgMongoManager, Manager $baseMongoManager){
        $this->orgMongoManager = $orgMongoManager;
        $this->baseMongoManager = $baseMongoManager;
    }

    /*

    Rota para search:
    style?page=1&limit=16&search=asd&search_in=name&search_in=type&search_in=description

    */

    public function getStyleFromBase($params){
        $filterCriteria = \Util\Utilities::parseParamNextToZmartFilterCriteria($this->dataSourceName,$params);

        $response = $this->baseMongoManager->findBy($filterCriteria)->getRows();

        foreach ($response as &$row) {
            $row['base'] = true;
        }

        return $response;
    }

    public function getStyleFromOrg($params){
        $filterCriteria = \Util\Utilities::parseParamNextToZmartFilterCriteria($this->dataSourceName,$params);

        $response = $this->orgMongoManager->findBy($filterCriteria)->getRows();

        return $response;
    }
}
